## dtknetworkmanager 1.0.3

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 - 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)

# If do't define version number, specify the version number
set (DTK_VERSION "5.6.12" CACHE STRING "define project version")

project(DtkNetworkManager
    LANGUAGES CXX
    HOMEPAGE_URL https://github.com/linuxdeepin/dtknetworkmanager
    DESCRIPTION "NetworkManager DBus interface binding for Qt"
    VERSION ${DTK_VERSION}
)

if(${PROJECT_VERSION_MAJOR} STREQUAL "5")
    set(QT_VERSION_MAJOR "5")
elseif(${PROJECT_VERSION_MAJOR} STREQUAL "6")
    set(QT_VERSION_MAJOR "6")
    set(DTK_VERSION_MAJOR "6")
endif()

# Install settings
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()

set(DtkNetworkManager Dtk${DTK_VERSION_MAJOR}NetworkManager)
set(LIB_NAME dtk${DTK_VERSION_MAJOR}networkmanager)

# specify install dir
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--as-needed")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/dtk${DTK_VERSION_MAJOR}/DNetworkManager)
set(LIBRARY_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR} CACHE STRING "Install dir for cmake config files")
set (CONFIG_CMAKE_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${DtkNetworkManager}" CACHE STRING "Install dir for cmake config files")

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose Debug or Release" FORCE)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
    set(BUILD_EXAMPLES ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
endif ()

find_package(PkgConfig)
pkg_search_module(NetworkManager REQUIRED IMPORTED_TARGET libnm>=1.4.0)
pkg_search_module(Gio REQUIRED IMPORTED_TARGET gio-2.0)
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core DBus Network)

add_subdirectory(src)

set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")
find_package(Doxygen)
if (BUILD_DOCS AND DOXYGEN_FOUND)
    add_subdirectory(docs)
endif ()

# test
if (BUILD_TESTING)
   add_subdirectory(tests)
endif ()

# examples
if (BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

target_link_directories(${LIB_NAME} INTERFACE
    $<INSTALL_INTERFACE:${LIBRARY_INSTALL_DIR}>
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/${DtkNetworkManager}ConfigVersion.cmake
    VERSION ${DTK_VERSION}
    COMPATIBILITY SameMajorVersion
)

configure_package_config_file(misc/DtkNetworkManagerConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/${DtkNetworkManager}Config.cmake
    INSTALL_DESTINATION ${CONFIG_CMAKE_INSTALL_DIR}
    PATH_VARS INCLUDE_INSTALL_DIR LIBRARY_INSTALL_DIR
)

# for pc file config
set(PC_LIBS_PRIVATE Qt${QT_VERSION_MAJOR}Core)
set(PC_REQ_PUBLIC "gio-2.0 libnm dtkcore")

# config pkgconfig file
set(PC_REQUIRES "Qt${QT_VERSION_MAJOR}Core Qt${QT_VERSION_MAJOR}DBus Qt${QT_VERSION_MAJOR}Network dtkcore Gio NetworkManager")
configure_file(misc/${LIB_NAME}.pc.in ${LIB_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LIB_NAME}.pc DESTINATION ${LIBRARY_INSTALL_DIR}/pkgconfig)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DtkNetworkManager}Config.cmake ${CMAKE_CURRENT_BINARY_DIR}/${DtkNetworkManager}ConfigVersion.cmake DESTINATION ${CONFIG_CMAKE_INSTALL_DIR})

# config qmake moudule file
set(DTK_MODULE ${LIB_NAME})
set(DTK_DEPS "core dbus network dtkcore")
set(DTK_CFG "v2 ltcg")
set(QMKSPECS_INSTALL_DIR "${LIBRARY_INSTALL_DIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "INSTALL DIR FOR qt pri files")
configure_file(misc/qt_lib_${LIB_NAME}.pri.in qt_lib_${LIB_NAME}.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_${LIB_NAME}.pri DESTINATION "${QMKSPECS_INSTALL_DIR}")

=== docs/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 - 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt${QT_VERSION_MAJOR}/doc CACHE STRING "QCH install location")
set(DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set(DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
set(DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set(DOXYGEN_FILE_PATTERNS *.cpp *.h *.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set(DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set(DOXYGEN_EXTRACT_STATIC YES)
set(DOXYGEN_OUTPUT_LANGUAGE "Chinese")
set(DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)
set(DOXYGEN_QHG_LOCATION "qhelpgenerator")
set(DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.networkmanager")
set(DOXYGEN_QCH_FILE "${LIB_NAME}.qch")
set(DOXYGEN_QHP_VIRTUAL_FOLDER ${CMAKE_PROJECT_NAME})
set(DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set(DOXYGEN_TAGFILES "qtcore.tags=qthelp://org.qt-project.qtcore/qtcore/" CACHE STRING "Doxygen tag files")
set(DOXYGEN_MACRO_EXPANSION "YES")
set(DOXYGEN_EXPAND_ONLY_PREDEF "YES")
set(DOXYGEN_PREDEFINED
    "DNETWORKMANAGER_BEGIN_NAMESPACE=namespace Dtk { namespace NetworkManager {"
    "DNETWORKMANAGER_END_NAMESPACE=}}"
    "DNETWORKMANAGER_USE_NAMESPACE=using namespace Dtk::NetworkManager;"
    "DTK_DNETWORKMANAGER_NAMESPACE=Dtk::NetworkManager"
)

doxygen_add_docs (doxygen
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/html/${LIB_NAME}.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== examples/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

add_executable(managerdemo managerdemo.cpp)

add_executable(devicedemo devicedemo.cpp)

target_link_libraries(managerdemo PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Network
    PkgConfig::Gio
    PkgConfig::NetworkManager
    ${LIB_NAME}
)

target_link_libraries(devicedemo PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Network
    PkgConfig::Gio
    PkgConfig::NetworkManager
    ${LIB_NAME}
)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 - 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB SETTING_HEADER "../include/settings/*h")
file(GLOB COMMON_HEADER "../include/*.h")

file(GLOB_RECURSE SRCS
    "./*.h"
    "./*.cpp"
)

add_library(${LIB_NAME} SHARED
    ${COMMON_HEADER}
    ${SETTING_HEADER}
    ${SRCS}
)

set(EXPORT_HEADERS ${COMMON_HEADER} ${SETTING_HEADER})

target_include_directories(${LIB_NAME}
PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/settings>
INTERFACE
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
)

target_link_directories(${LIB_NAME} INTERFACE
$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
$<INSTALL_INTERFACE:${LIBRARY_INSTALL_DIR}>)

target_compile_definitions(${LIB_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")

target_link_libraries(${LIB_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Network
    Dtk${DTK_VERSION_MAJOR}::Core
    PkgConfig::Gio
    PkgConfig::NetworkManager
)

set_target_properties(${LIB_NAME} PROPERTIES
    EXPORT_NAME NetworkManager
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    PUBLIC_HEADER "${EXPORT_HEADER}")

install(TARGETS ${LIB_NAME} EXPORT ${DtkNetworkManager}Targets
    LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
    PUBLIC_HEADER DESTINATION ${INCLUDE_INSTALL_DIR})

install(FILES ${COMMON_HEADER} DESTINATION ${INCLUDE_INSTALL_DIR}/)
install(FILES ${SETTING_HEADER} DESTINATION ${INCLUDE_INSTALL_DIR}/settings)

install(EXPORT ${DtkNetworkManager}Targets
    FILE ${DtkNetworkManager}Targets.cmake
    NAMESPACE Dtk${DTK_VERSION_MAJOR}::
    DESTINATION ${CONFIG_CMAKE_INSTALL_DIR}
)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 - 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(LIB_NAME ut-${LIB_NAME})

file(GLOB_RECURSE INCLUDE_FILES
    "../include/*.h"
)

file(GLOB_RECURSE SRCS
    "../src/*.h"
    "../src/*.cpp"
)

file(GLOB_RECURSE TEST_FILES "./*.h" "./*.cpp")

add_compile_definitions(USE_FAKE_INTERFACE)

add_executable(${LIB_NAME}
    ${INCLUDE_FILES}
    ${SRCS}
    ${TEST_FILES}
)

target_include_directories(${LIB_NAME} PRIVATE
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/include/settings
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/src/dbus
    ${PROJECT_SOURCE_DIR}/tests/fakeDBus
)

target_link_libraries(${LIB_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Network
    Dtk${DTK_VERSION_MAJOR}::Core
    PkgConfig::Gio
    PkgConfig::NetworkManager
    pthread
    gcov
    gtest
    gmock
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(${LIB_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(${LIB_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
endif()

target_compile_options(${LIB_NAME} PRIVATE -fno-access-control)

enable_testing()
add_test(NAME ${LIB_NAME} COMMAND ${LIB_NAME})

=== debian/changelog ===
dtknetworkmanager (1.0.3-1) unstable; urgency=medium

  * update

 -- Packages Builder <packages@deepin.com>  Tue, 17 Jan 2023 14:17:48 +0800

dtknetworkmanager (1.0.3) unstable; urgency=medium

  * Update changelog

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 17 Jan 2023 14:05:56 +0800

dtknetworkmanager (1.0.0) unstable; urgency=medium

  * Initial release

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 01 Jul 2022 14:29:07 +0800

=== debian/control ===
Source: dtknetworkmanager
Section: libdevel
Priority: optional
Maintainer: Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 libdtkcore-dev,
 qhelpgenerator-qt5 | qttools5-dev-tools,
 qtbase5-dev,
 doxygen,
 libnm-dev,
 libglib2.0-dev,
 graphviz
Standards-Version: 4.5.0

Package: libdtknetworkmanager
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Deepin Tool Kit template library
 libdtknetworkmanager is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtknetworkmanager-dev
Architecture: any
Depends:${misc:Depends}, libdtknetworkmanager( =${binary:Version})
Description: Deepin Tool Kit template devel library
 libdtknetworkmanager-dev is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5

PACK_VER = $(shell echo $(DEB_VERSION_UPSTREAM) | awk -F'[+_~-]' '{print $$1}')
# Fix: invalid digit "8" in octal constant. e.g.  u008 ==> 008 ==> 8
BUILD_VER = $(shell echo $(DEB_VERSION_UPSTREAM) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')

BUILD_EXAMPLES=OFF

BUILD_DOCS=ON

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_VERSION=${BUILD_VER} -DBUILD_EXAMPLES=${BUILD_EXAMPLES} -DBUILD_DOCS=${BUILD_DOCS} -DVERSION=$(PACK_VER)
